# Announce: Rakudo Star Release 2015.07

## A useful, usable, "early adopter" distribution of Perl 6

On behalf of the Rakudo and Perl 6 development teams, I'm happy to
announce the July 2015 release of "Rakudo Star", a useful and usable
distribution of Perl 6. The tarball for the July 2015 release is
available from <http://rakudo.org/downloads/star/>.

This Rakudo Star release comes with support for the MoarVM
backend (all module tests pass on supported platforms).

In the Perl 6 world, we make a distinction between the language
("Perl 6") and specific implementations of the language such as
"Rakudo Perl". This Star release includes [release 2015.07.2] of the
[Rakudo Perl 6 compiler], version 2015.07 of [MoarVM], plus various
modules, documentation, and other resources collected from the
Perl 6 community.

[release 2015.07]:
    https://github.com/rakudo/rakudo/blob/nom/docs/announce/2015.07.md
[Rakudo Perl 6 compiler]: http://github.com/rakudo/rakudo
[MoarVM]: http://moarvm.org/

Some of the new compiler features added to this release include:

* Cool.substr(-rw) and &substr(-rw) now also accept a Range
* Added trait "is required" on class attributes
* &?ROUTINE and &?BLOCK
* &words implemented (to completement .words)
* Numeric comparison ops (== > etc) for DateTimes
* samewith() now also works in subs
* Calling the .clone method with alternate values no longer changes original
* .grep and &grep now consume multiple elements for many-param blocks
* ENTER phaser now can be used as an r-value

Notable changes in modules shipped with Rakudo Star:

* Bailador: Add links to documentation
* DBIish: Use Postgres environment variables for test configuration
* doc: More documentation, mostly for IO-related classes and methods

There are some key features of Perl 6 that Rakudo Star does not yet
handle appropriately, although they will appear in upcoming releases.
Some of the not-quite-there features include:

  * advanced macros
  * non-blocking I/O (in progress)
  * much of Synopsis 9 and 11

There is an online resource at <http://perl6.org/compilers/features>
that lists the known implemented and missing features of Rakudo's
backends and other Perl 6 implementations.

In many places we've tried to make Rakudo smart enough to inform the
programmer that a given feature isn't implemented, but there are many
that we've missed. Bug reports about missing and broken features are
welcomed at <rakudobug@perl.org>.

See <http://perl6.org/> for links to much more information about
Perl 6, including documentation, example code, tutorials, reference
materials, specification documents, and other supporting resources. A
draft of a Perl 6 book is available as docs/UsingPerl6-draft.pdf in
the release tarball.

The development team thanks all of the contributors and sponsors for
making Rakudo Star possible. If you would like to contribute, see
<http://rakudo.org/how-to-help>, ask on the <perl6-compiler@perl.org>
mailing list, or join us on IRC \#perl6 on freenode.
